/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.fidentis.analyst.feature.services;

import cz.fidentis.analyst.feature.FeaturePoint;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author kubok
 */
public class FeaturePointsCsvExporter {
    
        public FeaturePointsCsvExporter() {
            
        }
   
        public void exportFeaturePointsToCSV(List<FeaturePoint> featurePointList, String objectName) throws IOException {
        File csvOutputFile = new File(String.format("%s_landmarks.csv", objectName));
        try (BufferedWriter bw = new BufferedWriter(new FileWriter(csvOutputFile))) {
            bw.write("Scan name");
            featurePointList.forEach(featurePoint -> {
                try {
                    bw.write(String.format(",%s x", featurePoint.getFeaturePointType().getCode()));
                    bw.write(String.format(",%s y", featurePoint.getFeaturePointType().getCode()));
                    bw.write(String.format(",%s z", featurePoint.getFeaturePointType().getCode()));
                } catch (IOException ex) {
                    Logger.getLogger(FeaturePointImportService.class.getName()).log(Level.SEVERE, null, ex);
                }
            });
            bw.newLine();
            bw.write(String.format("%s", objectName));
            featurePointList.forEach(featurePoint -> {
                try {
                    bw.write(",");
                    bw.write(Double.toString(featurePoint.getX()));
                    bw.write(",");
                    bw.write(Double.toString(featurePoint.getY()));
                    bw.write(",");
                    bw.write(Double.toString(featurePoint.getZ()));
                } catch (IOException ex) {
                    Logger.getLogger(FeaturePointImportService.class.getName()).log(Level.SEVERE, null, ex);
                }
            });
        }
    }

//    public static void marshal() throws JAXBException, IOException {
//        FeaturePointType fpt = new FeaturePointType(
//                1,
//                "Exocanthion R",
//                "The point at the outer commissure of the eye where the outer margin of the upper eyelid meets the lower eyelid. If the precise spot cannot be found then the location is in the intersection of imaginary lines obtained by prolonging the eyelid margins. The point is bilateral.",
//                "EX_R");
//        FeaturePoint fp = new FeaturePoint(10, 20, 30, fpt);
//
//        JAXBContext context = JAXBContext.newInstance(FeaturePoint.class);
//        Marshaller mar = context.createMarshaller();
//        mar.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
//        mar.marshal(fp, new File("./fp.xml"));
//    }
//
//    public static FeaturePoint unmarshall() throws JAXBException, IOException {
//        JAXBContext context = JAXBContext.newInstance(FeaturePoint.class);
//        return (FeaturePoint) context.createUnmarshaller()
//                .unmarshal(new FileReader("./fp.xml"));
//    }
//
//    public static void main() throws JAXBException, IOException {
//        marshal();
//        unmarshall();
//    }
    
}
